// APISpyTrace.cpp : implementation file
//

#include "stdafx.h"
#include "IOSpy.h"
#include "APISpyTrace.h"
#include "../Common/APISpy.h"

UINT WM_API_SPY = RegisterWindowMessage( API_SPY_TRACE_CLASS_NAME );

// CAPISpyTrace

IMPLEMENT_DYNAMIC(CAPISpyTrace, CWnd)

CAPISpyTrace::CAPISpyTrace()
{
	m_pParentWnd = NULL;
}

CAPISpyTrace::~CAPISpyTrace()
{
}


BEGIN_MESSAGE_MAP(CAPISpyTrace, CWnd)
	ON_WM_COPYDATA()
END_MESSAGE_MAP()

BOOL CAPISpyTrace::Create( CWnd *pParentWnd )
{
	//
	// we absolutely need a parent window
	//
	ASSERT( pParentWnd != NULL );
	if( pParentWnd == NULL )
		return FALSE;

	m_pParentWnd = pParentWnd;

	//
	// register a window class
	//
	WNDCLASS wc = { 0, AfxWndProc, 0, 0, AfxGetInstanceHandle(), NULL, NULL,
					(HBRUSH)( COLOR_WINDOW + 1 ), NULL, API_SPY_TRACE_CLASS_NAME };

	//
	// now create the window
	//
	return ( AfxRegisterClass( &wc ) &&
			 CWnd::Create( API_SPY_TRACE_CLASS_NAME, API_SPY_TRACE_CLASS_NAME,
						   0, CRect( 1, 1, 2, 2 ), CWnd::FromHandle( HWND_MESSAGE ), 0 ) );
}

// CAPISpyTrace message handlers

BOOL CAPISpyTrace::OnCopyData( CWnd *pWnd, COPYDATASTRUCT *pCopyData )
{
	ASSERT( m_pParentWnd != NULL );
	if( m_pParentWnd == NULL )
		return FALSE;

	m_pParentWnd->SendMessage( WM_API_SPY, (WPARAM)( pWnd->GetSafeHwnd() ), (LPARAM)pCopyData );
	return TRUE;
}
