// IOSpyDlg.cpp : implementation file
//

#include "stdafx.h"
#include "IOSpy.h"
#include "IOSpyDlg.h"
#include "ToolHelp.h"
#include "../Common/APISpy.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CIOSpyDlg dialog




CIOSpyDlg::CIOSpyDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIOSpyDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CIOSpyDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PROCESS_LIST, m_ctrlProcessList);
	DDX_Control(pDX, IDC_EVENT_LIST, m_ctrlEventsList);
}

BEGIN_MESSAGE_MAP(CIOSpyDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED( IDB_REFRESH_PROCESS_LIST, OnBnClickedRefreshProcessList )
	ON_BN_CLICKED(IDB_START_STOP_SPYING, &CIOSpyDlg::OnBnClickedStartStopSpying)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_PROCESS_LIST, &CIOSpyDlg::OnLvnItemchangedProcessList)
	ON_REGISTERED_MESSAGE( WM_API_SPY, OnAPISpy )
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDB_CLEAR_EVENTS, &CIOSpyDlg::OnBnClickedClearEvents)
END_MESSAGE_MAP()


// CIOSpyDlg message handlers

BOOL CIOSpyDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	//
	// initialize the process list control
	//
	CRect rcList;
	m_ctrlProcessList.GetClientRect( &rcList );

	m_ctrlProcessList.InsertColumn( 0, CString( (LPCSTR)IDS_PROCESS_ID ), 0, rcList.Width() * 20 / 100 );
	m_ctrlProcessList.InsertColumn( 1, CString( (LPCSTR)IDS_PROCESS_NAME ), 0, rcList.Width() * 70 / 100 );
	m_ctrlProcessList.SetExtendedStyle( LVS_EX_FULLROWSELECT );

	//
	// initialize the events list control
	//
	m_ctrlEventsList.GetClientRect( &rcList );

	m_ctrlEventsList.InsertColumn( 0, CString( (LPCSTR)IDS_PROCESS_ID ), 0, rcList.Width() * 10 / 100 );
	m_ctrlEventsList.InsertColumn( 1, CString( (LPCSTR)IDS_EVENT_NAME ), 0, rcList.Width() * 80 / 100 );
	m_ctrlEventsList.SetExtendedStyle( LVS_EX_FULLROWSELECT );

	//
	// load the process list
	//
	LoadProcessList();

	//
	// set up our API trace hidden window
	//
	m_wndAPISpyTrace.Create( this );
	ASSERT( m_wndAPISpyTrace.GetSafeHwnd() != NULL );

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CIOSpyDlg::OnBnClickedRefreshProcessList()
{
	LoadProcessList();
}

void CIOSpyDlg::LoadProcessList()
{
	//
	// get the list of processes
	//
	if( CToolHelp::GetProcessList32( m_listProcesses ) == false )
	{
		CString strMessage;
		strMessage.Format( IDS_PROCESS_LIST_ERROR, GetLastError() );
		AfxMessageBox( strMessage, MB_OK | MB_ICONHAND );
		return;
	}

	//
	// now populate the list control
	//
	m_ctrlProcessList.DeleteAllItems();
	vector<PROCESSENTRY32>::const_iterator it = m_listProcesses.begin();
	int index = 0;
	CString strText;

	while( it != m_listProcesses.end() )
	{
		strText.Format( _T( "%d" ), it->th32ProcessID );
		index = m_ctrlProcessList.InsertItem( index, strText );
		m_ctrlProcessList.SetItem( index, 1, LVIF_TEXT, PathFindFileName( it->szExeFile ), 0, 0, 0, 0 );

		++it;
		++index;
	}

	//
	// show number of processes
	//
	strText.Format( IDS_DIALOG_TITLE, m_listProcesses.size() );
	SetWindowText( strText );
}

void CIOSpyDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CIOSpyDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CIOSpyDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CIOSpyDlg::OnBnClickedStartStopSpying()
{
	//
	// get the currently selected item
	//
	POSITION pos = m_ctrlProcessList.GetFirstSelectedItemPosition();
	if( pos == NULL )
		return;

	int index = m_ctrlProcessList.GetNextSelectedItem( pos );

	//
	// is this process being spied on right now?
	//
	bool bIsSpying = ( m_ctrlProcessList.GetItemData( index ) == TRUE );

	CToolHelp::LoadLibraryRemote( m_listProcesses[index].th32ProcessID, _T( "detoured.dll" ) );
	CToolHelp::LoadLibraryRemote( m_listProcesses[index].th32ProcessID, _T( "apispy.dll" ) );

	//
	// mark this item in the list as being spied or not
	//
	m_ctrlProcessList.SetItemData( index, !bIsSpying );
}

void CIOSpyDlg::OnLvnItemchangedProcessList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);

	//
	// disable the start spying button if we are already
	// spying on this process
	//
	bool bIsSpying = ( m_ctrlProcessList.GetItemData( pNMLV->iItem ) == TRUE );
	GetDlgItem( IDB_START_STOP_SPYING )->EnableWindow( bIsSpying == false );

	*pResult = 0;
}

LRESULT CIOSpyDlg::OnAPISpy( WPARAM wParam, LPARAM lParam )
{
	PCOPYDATASTRUCT		pData = (PCOPYDATASTRUCT)lParam;
	std::stringstream	stream( ios_base::in | ios_base::out | ios_base::binary );
	API_SPY_TRACE		trace;

	//
	// read the trace information
	//
	stream.write( (const char *)pData->lpData, (std::streamsize)pData->cbData );
	stream.seekg( 0 );
	stream.read( (char *)&trace, sizeof( API_SPY_TRACE ) );

	//
	// process the message
	//
	switch( trace.opcode )
	{
	case opCopyFile:
	case opMoveFile:
		{
			//
			// read the from and to file paths
			//
			int		fromLength, toLength;
			WCHAR	*pFrom, *pTo;

			//
			// read the from path
			//
			stream>>fromLength;
			pFrom = new WCHAR[fromLength + 1];
			stream.read( (char *)pFrom, sizeof( WCHAR ) * fromLength );
			pFrom[fromLength] = L'\0';

			//
			// read the to path
			//
			stream>>toLength;
			pTo = new WCHAR[toLength + 1];
			stream.read( (char *)pTo, sizeof( WCHAR ) * toLength );
			pTo[toLength] = L'\0';

			//
			// add this to our list control
			//
			USES_CONVERSION;
			CString strText;

			//
			// write the PID
			//
			strText.Format( _T( "%d" ), trace.pid );
			int index = m_ctrlEventsList.InsertItem( m_ctrlEventsList.GetItemCount(), strText );

			//
			// write the trace data
			//
			strText.Format( _T( "%s file \"%s\" to \"%s\"" ),
							( trace.opcode == opCopyFile ) ? _T( "Copied" ) : _T( "Moved" ),
							W2CT( pFrom ),
							W2CT( pTo ) );
			m_ctrlEventsList.SetItem( index, 1, LVIF_TEXT, strText, 0, 0, 0, 0 );

			delete [] pFrom;
			delete [] pTo;

			break;
		}

	case opDeleteFile:
		{
			//
			// read the deleted file path
			//
			int		length;
			WCHAR	*pFile;

			//
			// read the from path
			//
			stream>>length;
			pFile = new WCHAR[length + 1];
			stream.read( (char *)pFile, sizeof( WCHAR ) * length );
			pFile[length] = L'\0';

			//
			// add this to our list control
			//
			USES_CONVERSION;
			CString strText;

			//
			// write the PID
			//
			strText.Format( _T( "%d" ), trace.pid );
			int index = m_ctrlEventsList.InsertItem( m_ctrlEventsList.GetItemCount(), strText );

			//
			// write the trace data
			//
			strText.Format( _T( "Deleted file \"%s\"" ),
							W2CT( pFile ) );
			m_ctrlEventsList.SetItem( index, 1, LVIF_TEXT, strText, 0, 0, 0, 0 );

			delete [] pFile;
			break;
		}
	}

	return 0L;
}

void CIOSpyDlg::OnBnClickedClearEvents()
{
	m_ctrlEventsList.DeleteAllItems();
}
